Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util.concurrent.atomic
Class AtomicStampedReference

    java.lang.Object
      edu.emory.mathcs.backport.java.util.concurrent.atomic.AtomicStampedReference

public class AtomicStampedReference
extends java.lang.Object

An `AtomicStampedReference` maintains an object reference along with an integer "stamp", that can be updated atomically.

Implementation note. This implementation maintains stamped references by creating internal objects representing "boxed" [reference, integer] pairs.

Since:
  1.5
Author:
  Doug Lea

Constructor Summary
`AtomicStampedReference(java.lang.Object initialRef, int initialStamp)` Creates a new `AtomicStampedReference` with the given initial values.

Method Summary
`boolean` | `attemptStamp(java.lang.Object expectedReference, int newStamp)` Atomically sets the value of the stamp to the given update value if the current reference is `==` to the expected reference.
`boolean` | `compareAndSet(java.lang.Object expectedReference, java.lang.Object newReference, int expectedStamp, int newStamp)` Atomically sets the value of both the reference and stamp to the given update values if the current reference is `==` to the expected reference and the current stamp is equal to the expected stamp.
`java.lang.Object` | `get(int[] stampHolder)` Returns the current values of both the reference and the stamp.
`java.lang.Object` | `getReference()` Returns the current value of the reference.
`int` | `getStamp()` Returns the current value of the stamp.
`void` | `set(java.lang.Object newReference, int newStamp)` Unconditionally sets the value of both the reference and stamp.
`boolean` | `weakCompareAndSet(java.lang.Object expectedReference, java.lang.Object newReference, int expectedStamp, int newStamp)` Atomically sets the value of both the reference and stamp to the given update values if the current reference is `==` to the expected reference and the current stamp is equal to the expected stamp.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### AtomicStampedReference

    public AtomicStampedReference(java.lang.Object initialRef,
                                  int initialStamp)

  Creates a new `AtomicStampedReference` with the given initial values.

Parameters:
  `initialRef` - the initial reference
  `initialStamp` - the initial stamp

Method Detail

### getReference

    public java.lang.Object getReference()

  Returns the current value of the reference.

  Returns:
    the current value of the reference

### getStamp

    public int getStamp()

  Returns the current value of the stamp.

  Returns:
    the current value of the stamp

### get

    public java.lang.Object get(int[] stampHolder)

  Returns the current values of both the reference and the stamp. Typical usage is `int[1] holder; ref = v.get(holder);` .

  Parameters:
    `stampHolder` - an array of size of at least one. On return, `stampholder[0]` will hold the value of the stamp.
  Returns:
    the current value of the reference

### weakCompareAndSet

    public boolean weakCompareAndSet(java.lang.Object expectedReference,
                                     java.lang.Object newReference,
                                     int expectedStamp,
                                     int newStamp)

  Atomically sets the value of both the reference and stamp to the given update values if the current reference is `==` to the expected reference and the current stamp is equal to the expected stamp. Any given invocation of this operation may fail (return `false`) spuriously, but repeated invocation when the current value holds the expected value and no other thread is also attempting to set the value will eventually succeed.

  Parameters:
    `expectedReference` - the expected value of the reference
    `newReference` - the new value for the reference
    `expectedStamp` - the expected value of the stamp
    `newStamp` - the new value for the stamp
  Returns:
    true if successful

### compareAndSet

    public boolean compareAndSet(java.lang.Object expectedReference,
                                 java.lang.Object newReference,
                                 int expectedStamp,
                                 int newStamp)

  Atomically sets the value of both the reference and stamp to the given update values if the current reference is `==` to the expected reference and the current stamp is equal to the expected stamp.

  Parameters:
    `expectedReference` - the expected value of the reference
    `newReference` - the new value for the reference
    `expectedStamp` - the expected value of the stamp
    `newStamp` - the new value for the stamp
  Returns:
    true if successful

### set

    public void set(java.lang.Object newReference,
                    int newStamp)

  Unconditionally sets the value of both the reference and stamp.

  Parameters:
    `newReference` - the new value for the reference
    `newStamp` - the new value for the stamp

### attemptStamp

    public boolean attemptStamp(java.lang.Object expectedReference,
                                int newStamp)

  Atomically sets the value of the stamp to the given update value if the current reference is `==` to the expected reference. Any given invocation of this operation may fail (return `false`) spuriously, but repeated invocation when the current value holds the expected value and no other thread is also attempting to set the value will eventually succeed.

  Parameters:
    `expectedReference` - the expected value of the reference
    `newStamp` - the new value for the stamp
  Returns:
    true if successful

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD